# Soluble\Normalist

[![Build Status](https://travis-ci.org/belgattitude/solublecomponents.png?branch=master)](https://travis-ci.org/belgattitude/solublecomponents)
[![Code Coverage](https://scrutinizer-ci.com/g/belgattitude/solublecomponents/badges/coverage.png?s=aaa552f6313a3a50145f0e87b252c84677c22aa9)](https://scrutinizer-ci.com/g/belgattitude/solublecomponents/)
[![Scrutinizer Quality Score](https://scrutinizer-ci.com/g/belgattitude/solublecomponents/badges/quality-score.png?s=6f3ab91f916bf642f248e82c29857f94cb50bb33)](https://scrutinizer-ci.com/g/belgattitude/solublecomponents/)
[![Total Downloads](https://poser.pugx.org/soluble/solublecomponents/downloads.png)](https://packagist.org/packages/soluble/solublecomponents)
[![Dependency Status](https://www.versioneye.com/user/projects/52cc2674ec137549700001f3/badge.png)](https://www.versioneye.com/user/projects/52cc2674ec137549700001f3)
[![Latest Stable Version](https://poser.pugx.org/soluble/solublecomponents/v/stable.png)](https://packagist.org/packages/soluble/solublecomponents)
[![License](https://poser.pugx.org/soluble/solublecomponents/license.png)](https://packagist.org/packages/soluble/solublecomponents)

## Introduction

Normalist is an opensource zero configuration ORM for PHP 5.3+.

Normalist has been designed to provide an alternative to standard ORM's by 
allowing models to be dynamically guessed from your database structure, which 
make them usable without previous definition. Its beautiful API is inspired by Doctrine, Laravel Eloquent and 
Zend Framework 2, offers simple and intuitive methods to play with your database.

## Features

+ Automatic models and synthetic tables
+ Elegant and intuitive API
+ Secure, automatic protection against SQL injections
+ Comprehensive error reporting
+ Modernize your existing code
+ Easily integrable into every new or existing PHP project 
+ Support custom table prefix
+ Well documented 
+ Stable 100% unit tested, PSR-2 compliant
+ PHP 5.3+ namespaced
+ MIT licensed

## Requirements

Normalist is written in PHP 5.3 and currently supports MySQL/MariaDb 5.1+ (PDO_Mysql or MySQLi extensions).

## Installation

Soluble\Normalist can be installed via composer. For composer documentation, please refer to
[getcomposer.org](http://getcomposer.org/).


The recommended way to install Normalist is through `Composer <https://getcomposer.org/>`_.
Just add soluble/normalist in your composer.json file as described below

```sh
php composer.phar require soluble/normalist:0.*
```


## Documentation

Documentation is hosted on [Read the docs](http://soluble.readthedocs.org)



## Contributing